/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */
#include "KeosShader.h"
#include "KeosRenderSystem.h"
#include "KeosResourceManager.h"
#include "KeosMediaManager.h"
#include "KeosLogger.h"

namespace Keos
{

	//=======================================================================
    // CShader implementation
    //=======================================================================

    //-----------------------------------------------------------------------
	void CShader::LoadFromFile(const String& strFilename)
	{
		m_Shader = CResourceManager::Instance().Get<IShaderBase>(strFilename);

		if (!m_Shader)
		{
			// Create shader
			m_Shader = CMediaManager::Instance().LoadMediaFromFile<IShaderBase>(strFilename);

			// Addition in the resources
			CResourceManager::Instance().Add(strFilename, m_Shader);
		}
	}

	//-----------------------------------------------------------------------
	void CShader::Unload()
	{
		m_Shader = NULL;
	}

	//-----------------------------------------------------------------------
	const IShaderBase* CShader::GetShader() const
	{
		return m_Shader;
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, float fValue)
	{
		float Data[] = {fValue, 0.0f, 0.0f, 0.0f};
		m_Shader->SetParameter(strName, Data);
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, const TVector2F& Value)
	{
		float Data[] = {Value.x, Value.y, 0.0f, 0.0f};
		m_Shader->SetParameter(strName, Data);
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, const TVector3F& Value)
	{
		float Data[] = {Value.x, Value.y, Value.z, 0.0f};
		m_Shader->SetParameter(strName, Data);
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, const TVector4F& Value)
	{
		float Data[] = {Value.x, Value.y, Value.z, Value.w};
		m_Shader->SetParameter(strName, Data);
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, const CMatrix4& Value)
	{
		m_Shader->SetParameter(strName, Value);
	}

	//-----------------------------------------------------------------------
	void CShader::SetParameter(const String& strName, const CColor& Value)
	{
		float Data[4];
		Value.ToFloat(Data);
		m_Shader->SetParameter(strName, Data);
	}

} // namespace Keos
